<?php
namespace Planejamento\Logic\Cardapio;

use Geral\Entities\Servico;
use Geral\Util\DateUtil;
use Planejamento\Entities\Consserv;
use Planejamento\Entities\Diasemcons;
use Setforms2\Generator\Business\Field\Date;

/**
 * Created by JetBrains PhpStorm.
 * User: jorgefonseca
 * Date: 21/01/13
 * Time: 14:27
 */
class ConsumoServico
{

    public static function retornaComensaisEstimados($nrorg, $filial, $servico, $idDia){
        if (empty($idDia) === false) {
            /** @var $servicoRepository \Geral\Repositories\Servico */
            $servicoRepository = Servico::getRepository();
            $comensais = $servicoRepository->consultaComensaisEstimados($nrorg, $filial, $servico, $idDia);
            return $comensais;
        }
    }


    public static function deletaConsumoValidade($nrorg, $filial, $servico, $data,
        $idTipoCons){
        try {
            $conn = \Setforms2\Shared\Connection::getInstance();
            $del = "DELETE FROM CONSSERV
                          WHERE NRORG = $nrorg
                            AND DTCONSSERV = '$data'
                            AND CDFILIAL = $filial
                            AND CDSERVFILI = $servico
                            AND IDTIPOCONS NOT IN($idTipoCons)";

            $conn->execute($del);
//            $consumos = Consserv::getObjectsByWhere(
//                'CDFILIAL = ? AND CDSERVFILI = ? AND DTCONSSERV = ? AND NRORG = ?',
//                array($filial, $servico, $data, $nrorg)
//            );
//
//            /** @var $consumo Consserv */
//            foreach ($consumos as $consumo) {
//                $consumo->delete();
//                $connection->flush('Consserv');
//            }
//
//            $connection->commit();
//            return true;
        } catch (\Exception $e) {
            throw $e;
        }
    }


    public static function deletaConsumoTipo(
        $nrorg, $filial, $servico, $data, $idDia, $idQtde = null
    ) {
        /** @var \Planejamento\Repositories\Consserv $consservRepository */
        $consservRepository = Consserv::getRepository();
        $consservRepository->excluiConsumoTipo($nrorg, $filial, $servico, $data, $idDia, $idQtde);
    }


    public static function atualizaConsumo(
        $nrorg, $filial,
        $dtValidadeOld, $tpDiaOld, $produtoOld, $idConsOld,
        $dtValidade, $servico, $idCons, $tpDia, $produto, $qtd, $operador
    ){
        try {
            $dtValidade = DateUtil::getDataDeString($dtValidade, DateUtil::FORMATO_BRASILEIRO, true);
            $dtValidadeOld = DateUtil::getDataDeString($dtValidadeOld, DateUtil::FORMATO_BRASILEIRO_DATAHORA, true);

            /** @var $consumo Consserv */
            $consumo = Consserv::getObject(
                array('cdfilial' => $filial, 'nrorg' => $nrorg, 'dtconsserv' => $dtValidadeOld, 'cdservfili' => $servico,
                    'idqtdecons' => $idConsOld, 'idtipocons' => $tpDiaOld, 'cdproduto' => $produtoOld)
            );

            $dtAtual = DateUtil::getDataAtual();

            $connection = \Setforms2\Shared\Registry::getEntityManager();
            $connection->beginTransaction();

            $consumo->atualizaConsumo($nrorg, $filial, $dtValidade, $servico, $idCons, $tpDia, $produto, $qtd, $operador, $dtAtual);

            $connection->flush();
            $connection->commit();

            return true;
        } catch (\Exception $e) {
            $connection->rollback();
            throw $e;
        }
    }


    public static function salvaDiaSemConsumo($nrorg, $filial, $servico, $dtConsumo, $idTipo, $operador){
        $dtCons = DateUtil::getDataDeString($dtConsumo, DateUtil::FORMATO_BRASILEIRO, true);

        $objDiaSemCons = Diasemcons::getObject(
            array('nrorg' => $nrorg, 'cdfilial' => $filial, 'cdservfili' => $servico, 'dtsconsserv' => $dtCons)
        );

        $connection = \Setforms2\Shared\Registry::getEntityManager();

        try {
            if ($objDiaSemCons instanceof Diasemcons) {
                $objDiaSemCons->atualizaTipoConsumo($nrorg, $idTipo, $operador);
            } else {
                Diasemcons::insereDiaSemConsumo($nrorg, $filial, $servico, $dtCons, $idTipo, $operador);
            }

            $connection->flush();

            return true;
        } catch (\Exception $e) {
            $connection->rollback();
            throw $e;
        }
    }


    public static function excluiConsumoExcecao($nrorg, $filial, $servico, $dataConsumo){
        $connection = \Setforms2\Shared\Registry::getEntityManager();
        $connection->beginTransaction();

        try {
            $sql = "DELETE FROM DIASEMCONS
                     WHERE NRORG = $nrorg
                       AND CDFILIAL = '$filial'
                       AND CDSERVFILI = '$servico'
                       AND DTSCONSSERV = '$dataConsumo'";

            \Setforms2\Shared\Connection::getInstance()->execute($sql);

            $connection->flush();
            $connection->commit();

            return true;
        } catch (\Exception $e) {
            $connection->rollback();
            throw $e;
        }
    }


    public static function atualizaDiaSemConsumo($nrorg, $filial, $servico, $dtConsumo, $idTipo, $operador){
        $dtCons = DateUtil::getDataDeString($dtConsumo, DateUtil::FORMATO_BRASILEIRO, true);

        $objDiaSemCons = Diasemcons::getObjectByWhere(
            'NRORG = ? AND CDFILIAL = ? AND CDSERVFILI = ? AND DTSCONSSERV = ?',
            array($nrorg, $filial, $servico, $dtCons)
        );

        if ($objDiaSemCons instanceof Diasemcons) {
            $connection = \Setforms2\Shared\Registry::getEntityManager();
            $connection->beginTransaction();

            try {
                $objDiaSemCons->atualizaTipoConsumo($nrorg, $idTipo, $operador);

                $connection->flush();
                $connection->commit();
            } catch (\Exception $e) {
                $connection->rollback();
                throw $e;
            }
        }

        return true;
    }


    public static function salvaConsumo(
        $nrorg, $filial, $servico, $dtCons, $idCons, $tpCons, $produto, $qtde, $operador
    ){
        self::validaSave($nrorg, $filial, $servico, $dtCons, $idCons, $tpCons, $produto);

        $dtAtual = DateUtil::getDataAtual();
        $data = DateUtil::getDataDeString($dtCons, DateUtil::FORMATO_BRASILEIRO, true);
        $connection = \Setforms2\Shared\Registry::getEntityManager();

        try {
            $consumo = new Consserv();
            $consumo->insereConsumo(
                $nrorg, $filial, $servico, $data, $idCons, $tpCons, $produto, $qtde, $operador, $dtAtual
            );

            $connection->flush();
        } catch (\Exception $e) {
            throw $e;
        }
    }


    public static function validaSave(
        $nrorg, $filial, $servico, $dtCons, $idCons, $tpCons, $produto
    ){
        $dtValidade = DateUtil::getDataDeString($dtCons, DateUtil::FORMATO_BRASILEIRO, true);

        /** @var $consumo Consserv */
        $consumo = Consserv::getObject(
            array('cdfilial' => $filial, 'nrorg' => $nrorg, 'dtconsserv' => $dtValidade, 'cdservfili' => $servico,
                'idqtdecons' => $idCons, 'idtipocons' => $tpCons, 'cdproduto' => $produto)
        );

        if ($consumo instanceof Consserv) {
            tk_abort(tk_get_message_by_name('msg_pla00500_prodExisteConsumoIgual'));
        }

        return true;
    }


    public static function importaConsumo(
        $nrorg, $filial, $modo, $dtValidade, $servico, $consumo, $tpDia, $produto, $quantidade, $operador
    ){
        $dtValidade = DateUtil::getDataDeString($dtValidade, DateUtil::FORMATO_BRASILEIRO, true);

        /** @var $consumo Consserv */
        $cons = Consserv::getObject(
            array('cdfilial' => $filial, 'nrorg' => $nrorg, 'dtconsserv' => $dtValidade, 'cdservfili' => $servico,
                'idqtdecons' => $consumo, 'idtipocons' => $tpDia, 'cdproduto' => $produto)
        );

        if ($cons instanceof Consserv) {
            // Sobrepondo
            if($modo === 'S') {
                self::atualizaConsumo(
                    $nrorg, $filial, $dtValidade->format(DateUtil::FORMATO_BRASILEIRO_DATAHORA), $tpDia, $produto, $consumo,
                    $dtValidade->format(DateUtil::FORMATO_BRASILEIRO), $servico, $consumo, $tpDia, $produto, $quantidade, $operador
                );
            // Acrescentando
            } else if($modo === 'N'){
                try {
                    self::salvaConsumo(
                        $nrorg, $filial, $servico, $dtValidade->format(DateUtil::FORMATO_BRASILEIRO), $consumo, $tpDia, $produto, $quantidade, $operador
                    );
                } catch (\Exception $e) {
                }
            }
        } else {
            self::salvaConsumo(
                $nrorg, $filial, $servico, $dtValidade->format(DateUtil::FORMATO_BRASILEIRO), $consumo, $tpDia, $produto, $quantidade, $operador
            );
        }

        $diaSemConsumo = self::buscaDiaSemConsumo(
            $nrorg, $filial, $servico, $dtValidade->format(DateUtil::FORMATO_BRASILEIRO)
        );

        if (empty($diaSemConsumo) === false) {
            $idtconsserv = $diaSemConsumo->getIdtconsserv();
            if (($consumo === 'F' AND $idtconsserv === 'F')
                || ($consumo === 'P' AND $idtconsserv === 'P')
            ) {
                self::excluiConsumoExcecao(
                    $nrorg, $filial, $servico, $dtValidade->format(DateUtil::FORMATO_BRASILEIRO)
                );
            } else {
                if ($idtconsserv === 'A') {
                    if ($consumo === 'P') {
                        self::atualizaDiaSemConsumo(
                            $nrorg, $filial, $servico, $dtValidade->format(DateUtil::FORMATO_BRASILEIRO), 'F',
                            $operador
                        );
                    } else {
                        if ($consumo === 'F') {
                            self::atualizaDiaSemConsumo(
                                $nrorg, $filial, $servico, $dtValidade->format(DateUtil::FORMATO_BRASILEIRO), 'P',
                                $operador
                            );
                        }
                    }
                }
            }
        }

        return true;
    }


    public static function exportaConsumo(
        $nrorg, $filial, $modo, $dtInicio, $dtFinal, $arrayDias, $servico, $consumo,
        $tpDia, $produto, $quantidade, $operador
    ){
        if (is_array($arrayDias)) {
            $datas = self::buscaDatasExportacao($dtInicio, $dtFinal, $arrayDias);
        } else {
            $datas = array($dtInicio);
        }

        foreach ($datas as $data) {
            self::importaConsumo(
                $nrorg, $filial, $modo, $data, $servico, $consumo, $tpDia, $produto, $quantidade, $operador
            );
        }

        return true;
    }


    private static function buscaDatasExportacao($dtInicio, $dtFinal, $arrayDias){
        $datas = DateUtil::getDiaSemanaIntervDatas($dtInicio, $dtFinal);

        $arrayDtExport = array();

        foreach ($datas AS $data) {
            foreach ($arrayDias as $dia) {
                $diaData = DateUtil::getDiaSemana($data['DTDATA']);

                switch($diaData){
                    case "7":
                        $diaData = 1;
                        break;
                    default:
                        ++$diaData;
                        break;
                }

                if ($diaData === $dia) {
                    $arrayDtExport[] = $data['DTDATA'];
                    continue 2;
                }
            }
        }

        return $arrayDtExport;
    }

    public static function buscaConsumo(
        $nrorg, $filial, $servico, $dtCons, $idCons, $tpCons
    ){
        $dtCons = DateUtil::getDataDeString($dtCons, DateUtil::FORMATO_BRASILEIRO, true);

        $consumo = Consserv::getObjectsByWhere('NRORG = ? AND CDFILIAL = ? AND
        CDSERVFILI = ? AND DTCONSSERV = ? AND IDTIPOCONS = ? AND IDQTDECONS = ?',
            array($nrorg, $filial, $servico, $dtCons, $idCons, $tpCons)
        );

        return $consumo;
    }

    public static function buscaDiaSemConsumo(
        $nrorg, $filial, $servico, $dtDiaSemCons
    ){
        $dtDiaSemCons = DateUtil::getDataDeString($dtDiaSemCons, DateUtil::FORMATO_BRASILEIRO, true);

        $diaSemConsumo = Diasemcons::getObjectByWhere(
            'NRORG = ? AND CDFILIAL = ? AND CDSERVFILI = ? AND DTSCONSSERV = ?',
            array($nrorg, $filial, $servico, $dtDiaSemCons)
        );

        return $diaSemConsumo;
    }
}