/******************************************************************************/
/************************ GERA SUGESTO DE COMPRAS ****************************/

   IF EXISTS (SELECT *
              FROM SYSOBJECTS O, SYSUSERS U
              WHERE
	              O.NAME = 'GERA_SUGESTAO_COMPRA'  AND
	              TYPE = 'P'               AND
	              U.UID = O.UID            AND
	              U.NAME = USER)

   DROP PROCEDURE GERA_SUGESTAO_COMPRA
   GO

CREATE  PROCEDURE GERA_SUGESTAO_COMPRA  @P_CDFILIAL      VARCHAR(4),
                                         @P_CDFORNECED    VARCHAR(21),
                                         @P_PRODINI       VARCHAR(10),
                                         @P_PRODFIN       VARCHAR(10),
                                         @P_DTREFE        DATETIME,
                                         @P_NRDIACOMPRA   VARCHAR(3),
                                         @P_NRDIAEXCESS   VARCHAR(3),
                                         @P_DTQTDE1       DATETIME,
                                         @P_DTQTDE2       DATETIME,
                                         @P_DTQTDE3       DATETIME,
                                         @P_DTPOSICAO     DATETIME,
                                         @P_NRSUGCOMPRA   VARCHAR(20),
                                         @P_IDTPRELSUG    VARCHAR(1),
                                         @P_IDGERASOLCMP  VARCHAR(1),
                                         @P_CDCLIENTE     VARCHAR(21),
                                         @P_DEEXP         DATETIME,
                                         @P_ATEEXP        DATETIME,
                                         @P_TDATA         VARCHAR(1),
                                         @P_CDFILLAN      VARCHAR(4),
                                         @P_NRSOLICMP     VARCHAR(10),
                                         @P_DTENTSOLICMP  DATETIME,
                                         @P_IDMENSSOLI    VARCHAR(1) OUTPUT
AS
   DECLARE @V_NRLISTA      VARCHAR(20);
   DECLARE @V_QTSOLIPROD   DOUBLE PRECISION;
   DECLARE @V_NRITESUGCOMP INTEGER;
   DECLARE @V_CTITEMSOLI   INTEGER;
   DECLARE @V_NRNOTAFISC   VARCHAR(20);
   DECLARE @V_CDFORNECED   VARCHAR(21);
   DECLARE @V_DTENTRSAID   DATETIME;
   DECLARE @V_QTITEMPROD   DOUBLE PRECISION;
   DECLARE @V_VRUNITITEM   DOUBLE PRECISION;
   DECLARE @V_VRFRETE      DOUBLE PRECISION;
   DECLARE @V_VRIPI        DOUBLE PRECISION;
   DECLARE @V_QTPRZ        DOUBLE PRECISION;
   DECLARE @V_QTDE1        DOUBLE PRECISION;
   DECLARE @V_QTDE2        DOUBLE PRECISION;
   DECLARE @V_QTDE3        DOUBLE PRECISION;
   DECLARE @V_QTDEATUAL    DOUBLE PRECISION;
   DECLARE @V_QTPEDIDA     DOUBLE PRECISION;
   DECLARE @V_QTESTOQUE    DOUBLE PRECISION;
   DECLARE @V_QTMEDIAMES   DOUBLE PRECISION;
   DECLARE @V_QTCOMPRA     DOUBLE PRECISION;
   DECLARE @V_QTEXCESSO    DOUBLE PRECISION;
   DECLARE @V_GERA_QTDE1   DOUBLE PRECISION;
   DECLARE @V_GERA_QTDE2   DOUBLE PRECISION;
   DECLARE @V_GERA_QTDE3   DOUBLE PRECISION;
   DECLARE @V_GERA_QTDEATU DOUBLE PRECISION;
   DECLARE @V_GERA_QTPED   DOUBLE PRECISION;
   DECLARE @V_GERA_QTEST   DOUBLE PRECISION;
   DECLARE @V_CONT         INTEGER;
   DECLARE @V_EXIST        INTEGER;
   DECLARE @V_IDMENSSOLI   VARCHAR(1);
   DECLARE @C_FORN_CDFORNECED VARCHAR(21);
   DECLARE @C_REG_CDPRODUTO  VARCHAR(10);
   DECLARE @C_REG_CDARVPROD  VARCHAR(10);
   DECLARE @C_REG_SGUNIDADE  VARCHAR(2);
   DECLARE @C_REG_NMPRODUTO  VARCHAR(50);
   DECLARE @C_REG_VRFATOCONV DOUBLE PRECISION;

   DECLARE @C_ULTCOMP_CDFILIAL      VARCHAR(4);
   DECLARE @C_ULTCOMP_NRLANCTONF    VARCHAR(10);
   DECLARE @C_ULTCOMP_NRNOTAFISC    VARCHAR(20);
   DECLARE @C_ULTCOMP_DTENTRSAID    DATETIME;
   DECLARE @C_ULTCOMP_CDFORNECED    VARCHAR(21);
   DECLARE @C_ULTCOMP_NRINSJURFORN  VARCHAR(20);
   DECLARE @C_ULTCOMP_NMRAZSOCFORN  VARCHAR(40);
   DECLARE @C_ULTCOMP_IDTPIJURFORN  VARCHAR(1);
   DECLARE @C_ULTCOMP_VRIPI         DOUBLE PRECISION;
   DECLARE @C_ULTCOMP_VRFRETE       DOUBLE PRECISION;
   DECLARE @C_ULTCOMP_QTPRZ         DOUBLE PRECISION;
   DECLARE @C_ULTCOMP_QTITEMPROD    DOUBLE PRECISION;
   DECLARE @C_ULTCOMP_VRUNITITEM    DOUBLE PRECISION;

   DECLARE @C_PED_CDFORNECED   VARCHAR(21);
   DECLARE @C_PED_CDPRODUTO    VARCHAR(10);
   DECLARE @C_PED_NRPEDIDO     VARCHAR(10);
   DECLARE @C_PED_NRITEMPED    VARCHAR(10);
   DECLARE @C_PED_QTITEMPED    DOUBLE PRECISION;
   DECLARE @C_PED_QTEXPITEMPED DOUBLE PRECISION;
   DECLARE @C_PED_CDCLIENTE    VARCHAR(21);
   DECLARE @C_PED_VRFATOCONV   DOUBLE PRECISION;
BEGIN
   SET @V_NRITESUGCOMP = 1;
   SET @V_NRNOTAFISC   = '';
   SET @V_CDFORNECED   = '';
   SET @V_QTITEMPROD   = 0;
   SET @V_VRUNITITEM   = 0;
   SET @V_VRFRETE      = 0;
   SET @V_VRIPI        = 0;
   SET @V_QTPRZ        = 0;
   SET @V_QTDE1 = 0;
   SET @V_QTDE2 = 0;
   SET @V_QTDE3 = 0;
   SET @V_QTDEATUAL  = 0;
   SET @V_QTPEDIDA   = 0;
   SET @V_QTESTOQUE  = 0;
   SET @V_QTMEDIAMES = 0;
   SET @V_QTCOMPRA   = 0;
   SET @V_QTEXCESSO  = 0;
   SET @V_GERA_QTDE1 = 0;
   SET @V_GERA_QTDE2 = 0;
   SET @V_GERA_QTDE3 = 0;
   SET @V_GERA_QTDEATU = 0;
   SET @V_GERA_QTPED   = 0;
   SET @V_GERA_QTEST   = 0;
   SET @V_CONT         = 0;
   SET @V_EXIST        = 0;
   SET @P_IDMENSSOLI   = 0;

   IF @P_IDTPRELSUG = '1' BEGIN
      EXEC NOVO_CODIGO 'LISTA', @P_SEQUENCIAL = @V_NRLISTA OUTPUT, @P_QTDE = 1;
      SET @V_NRLISTA = SUBSTRING(@V_NRLISTA, 11, 10);

      DECLARE C_FORN CURSOR FOR
      SELECT CDFORNECED
      FROM FORNECEDOR
      WHERE
      (CHARINDEX( '_' + CDFORNECED + '_', ISNULL(@P_CDFORNECED, '_' + CDFORNECED + '_')) > 0);

      OPEN C_FORN;
      FETCH NEXT FROM C_FORN INTO  @C_FORN_CDFORNECED;
      WHILE (@@FETCH_STATUS = 0) BEGIN
         INSERT INTO LISTA
           (NRLISTA, CDLISTA)
         VALUES
           ( @V_NRLISTA, @C_FORN_CDFORNECED);
         FETCH NEXT FROM C_FORN INTO  @C_FORN_CDFORNECED;
      END;
      CLOSE C_FORN;
      DEALLOCATE C_FORN;

      DECLARE C_REG CURSOR FOR
         SELECT PR.CDPRODUTO, PR.CDARVPROD, PR.SGUNIDADE, PR.NMPRODUTO, PR.VRFATOCONV
         FROM PRODUTO PR
         WHERE
            (PR.CDPRODESTO IS NOT NULL)
            AND (CDARVPROD BETWEEN @P_PRODINI AND @P_PRODFIN)
            AND EXISTS(SELECT PF.CDPRODUTO
                       FROM PRODUTO P, PRODFORN PF, LISTA LI
                       WHERE
                          (LI.NRLISTA    = @V_NRLISTA)
                          AND (PF.CDFORNECED = LI.CDLISTA)
                          AND (PF.CDPRODUTO  = P.CDPRODUTO)
                          AND (PR.CDARVPROD LIKE P.CDARVPROD +'%'));
      OPEN C_REG;
      FETCH NEXT FROM C_REG INTO  @C_REG_CDPRODUTO, @C_REG_CDARVPROD, @C_REG_SGUNIDADE, @C_REG_NMPRODUTO, @C_REG_VRFATOCONV;

      WHILE (@@FETCH_STATUS = 0) BEGIN
         SELECT  @V_GERA_QTDE1 = MAX(QT1.QTDE1),  @V_GERA_QTDE2 = MAX(QT2.QTDE2),  @V_GERA_QTDE3 = MAX(QT3.QTDE3),
                 @V_GERA_QTDEATU = MAX(QTATU.QTDEATUAL), @V_GERA_QTEST = MAX(POSEST.QTESTOQUE), @V_GERA_QTPED = MAX(PEDIDA.QTPEDIDA)
            FROM
            (SELECT ISNULL(SUM(QTITEMPROD),0) AS QTDE1
             FROM ITEMPRODUTO IP, NOTAFISCAL NF, DATA DT
             WHERE (NF.CDFILIEMIT   = @P_CDFILIAL)
               AND (NF.IDENTRSAIDOP = 'S')
               AND (DT.DTMES        = @P_DTQTDE1)
               AND (NF.DTENTRSAID   = DT.DTDATA)
               AND (IP.CDPRODUTO    = @C_REG_CDPRODUTO )
               AND (NF.CDFILIAL     = IP.CDFILIAL)
               AND (NF.NRLANCTONF   = IP.NRLANCTONF)) QT1,
            (SELECT ISNULL(SUM(QTITEMPROD),0) AS QTDE2
             FROM ITEMPRODUTO IP, NOTAFISCAL NF, DATA DT
             WHERE (NF.CDFILIEMIT   = @P_CDFILIAL)
               AND (NF.IDENTRSAIDOP = 'S')
               AND (DT.DTMES        = @P_DTQTDE2)
               AND (NF.DTENTRSAID   = DT.DTDATA)
               AND (IP.CDPRODUTO    = @C_REG_CDPRODUTO)
               AND (NF.CDFILIAL     = IP.CDFILIAL)
               AND (NF.NRLANCTONF   = IP.NRLANCTONF)) QT2,
            (SELECT ISNULL(SUM(QTITEMPROD),0) AS QTDE3
             FROM ITEMPRODUTO IP, NOTAFISCAL NF, DATA DT
             WHERE (NF.CDFILIEMIT   = @P_CDFILIAL)
               AND (NF.IDENTRSAIDOP = 'S')
               AND (DT.DTMES        = @P_DTQTDE3)
               AND (NF.DTENTRSAID   = DT.DTDATA)
               AND (IP.CDPRODUTO    = @C_REG_CDPRODUTO)
               AND (NF.CDFILIAL     = IP.CDFILIAL)
               AND (NF.NRLANCTONF   = IP.NRLANCTONF)) QT3,
            (SELECT ISNULL(SUM(QTITEMPROD),0) AS QTDEATUAL
             FROM ITEMPRODUTO IP, NOTAFISCAL NF, DATA DT
             WHERE (NF.CDFILIEMIT   = @P_CDFILIAL)
               AND (NF.IDENTRSAIDOP = 'S')
               AND (DT.DTMES        = (CONVERT( DATETIME,
                                       CONVERT( VARCHAR, DATEPART(DD, CONVERT(DATETIME,'01/01/2001')))+'/'  +
                                       CONVERT( VARCHAR, DATEPART(MM,  @P_DTREFE))+'/'  +
                                       CONVERT( VARCHAR, DATEPART(YYYY,@P_DTREFE)))))
               AND (NF.DTENTRSAID   = DT.DTDATA)
               AND (NF.DTENTRSAID  <= @P_DTREFE)
               AND (NF.CDFILIAL     = IP.CDFILIAL)
               AND (NF.NRLANCTONF   = IP.NRLANCTONF)
               AND (IP.CDPRODUTO    = @C_REG_CDPRODUTO)) QTATU,
            (SELECT PE.QTESTDIACON AS QTESTOQUE
             FROM POSESTCONS PE
             WHERE (PE.CDFILIAL  =  @P_CDFILIAL)  AND
                   (PE.CDPRODUTO =  @C_REG_CDPRODUTO) AND
                   (PE.DTPOSESTCON = TEKNISA.DTMAXPOSEST(@P_CDFILIAL, @C_REG_CDPRODUTO, @P_DTPOSICAO + 1))) POSEST,
            (SELECT ISNULL(SUM(QTPROGENTAF),0) AS QTPEDIDA
             FROM AUTOFORNE AF, ITEMAUTF IA
             WHERE (AF.CDFILDEST  = @P_CDFILIAL)                                            AND
                   (AF.IDBAIXAAF IS NULL)                                                   AND
                   (CHARINDEX( '_' + AF.CDFORNECED + '_', ISNULL(@P_CDFORNECED, '_' + AF.CDFORNECED + '_') ) > 0) AND
                   (AF.CDFILDEST  = IA.CDFILDEST)                                           AND
                   (AF.CDFILLANC  = IA.CDFILLANC)                                           AND
                   (AF.NRAUTOFORN = IA.NRAUTOFORN)                                          AND
                   (IA.DTPROGENTAF < @P_DTPOSICAO + 1)                                      AND
                   (IA.CDPRODUTO  = @C_REG_CDPRODUTO)                                       AND
                   (AF.IDSITUATUAAF IS NULL)                                                AND
                   (AF.IDAFFORALIM = 'N')) PEDIDA ;

         IF ( @V_GERA_QTDE1 <> 0  )OR(@V_GERA_QTDE2 <>0 )OR(@V_GERA_QTDE3 <> 0)OR
            ( @V_GERA_QTDEATU <> 0)OR(@V_GERA_QTEST <> 0)OR(@V_GERA_QTPED <>0) BEGIN
            SET @V_QTDE1      = @V_GERA_QTDE1;
            SET @V_QTDE2      = @V_GERA_QTDE2;
            SET @V_QTDE3      = @V_GERA_QTDE3;
            SET @V_QTDEATUAL  = @V_GERA_QTDEATU;
            SET @V_QTESTOQUE  = ISNULL(@V_GERA_QTEST, 0) * ISNULL(@C_REG_VRFATOCONV, 1);
            SET @V_QTMEDIAMES = ((@V_GERA_QTDE1 + @V_GERA_QTDE2 + @V_GERA_QTDE3)/3);
            SET @V_QTPEDIDA   = @V_GERA_QTPED;
            SET @V_QTCOMPRA   = ((((( @V_GERA_QTDE1 + @V_GERA_QTDE2 + @V_GERA_QTDE3)/3)/30) * CONVERT(INTEGER, @P_NRDIACOMPRA)) - @V_QTESTOQUE - @V_QTPEDIDA);
            SET @V_QTEXCESSO  = ( @V_QTESTOQUE + @V_QTPEDIDA - (((( @V_GERA_QTDE1 + @V_GERA_QTDE2 + @V_GERA_QTDE3) / 3)/30)* CONVERT(INTEGER, @P_NRDIAEXCESS)));
         END;

         SET @V_CONT = 0;
         DECLARE C_ULTCOMP CURSOR FOR
            SELECT NF.CDFILIAL, NF.NRLANCTONF, NF.NRNOTAFISC, NF.DTENTRSAID,NF.CDFORNECED,
                   FN.NRINSJURFORN, FN.NMRAZSOCFORN, FN.IDTPIJURFORN, IT.VRALIQITEM AS VRIPI,
                   IE.VRITEMENCA AS VRFRETE, MIN(CP.QTDIASVENPAG) AS QTPRZ,
                   SUM(IP.QTITEMPROD) AS QTITEMPROD,
                   (SUM(IP.VRTOTAITEM)/ SUM(IP.QTITEMPROD)) AS VRUNITITEM
            FROM
               FORNECEDOR FN,
               ITEMPRODUTO IP LEFT JOIN ITEMPROIMPOS IT ON
                              ((IP.CDFILIAL     = IT.CDFILIAL   )AND
                               (IP.NRLANCTONF   = IT.NRLANCTONF )AND
                               (IP.NRSEQITPROD  = IT.NRSEQITPROD)AND
                               (IT.CDIMPOSTO    = '10')           AND
                               (IT.NRITPROIMPOS = '1' )
                               ),
               NOTAFISCAL NF LEFT JOIN  ITEMENCARGO IE ON
                               ((NF.CDFILIAL   = IE.CDFILIAL)  AND
                               (NF.NRLANCTONF = IE.NRLANCTONF)AND
                               (IE.CDENCARGO  = '01'))
                             LEFT JOIN CONTAPAGAR CP ON
                               ((NF.CDFILIAL   = CP.CDFILIAL)    AND
                                (NF.NRLANCTONF = CP.NRLANCTONF))
            WHERE
               (NF.CDFILIRECE   = @P_CDFILIAL)       AND
               (NF.IDENTRSAIDOP = 'E')               AND
               (NF.CDTIPOOPER   = '01')              AND
               (NF.CDFILIAL     = IP.CDFILIAL)       AND
               (NF.NRLANCTONF   = IP.NRLANCTONF)     AND
               (IP.CDPRODUTO    = @C_REG_CDPRODUTO)   AND
               (NF.CDFORNECED   = FN.CDFORNECED)     AND
               (CHARINDEX( '_' + NF.CDFORNECED + '_', ISNULL(@P_CDFORNECED, '_' + NF.CDFORNECED + '_')) > 0)
            GROUP BY NF.CDFILIAL, NF.NRLANCTONF, NF.NRNOTAFISC, NF.DTENTRSAID, NF.CDFORNECED,
                  FN.NRINSJURFORN, FN.NMRAZSOCFORN, FN.IDTPIJURFORN, IT.VRALIQITEM, IE.VRITEMENCA
            ORDER BY NF.DTENTRSAID DESC , NF.NRLANCTONF DESC
         OPEN C_ULTCOMP;
         FETCH NEXT FROM C_ULTCOMP INTO @C_ULTCOMP_CDFILIAL, @C_ULTCOMP_NRLANCTONF,
                                        @C_ULTCOMP_NRNOTAFISC, @C_ULTCOMP_DTENTRSAID,
                                        @C_ULTCOMP_CDFORNECED, @C_ULTCOMP_NRINSJURFORN,
                                        @C_ULTCOMP_NMRAZSOCFORN, @C_ULTCOMP_IDTPIJURFORN,
                                        @C_ULTCOMP_VRIPI, @C_ULTCOMP_VRFRETE, @C_ULTCOMP_QTPRZ,
                                        @C_ULTCOMP_QTITEMPROD, @C_ULTCOMP_VRUNITITEM;

         WHILE (@@FETCH_STATUS = 0) BEGIN
            IF NOT ((@C_ULTCOMP_CDFILIAL IS NULL) OR (@C_ULTCOMP_NRLANCTONF IS NULL)
               OR (@C_ULTCOMP_NRNOTAFISC IS NULL)) BEGIN
               SET @V_CDFORNECED = @C_ULTCOMP_CDFORNECED;
               SET @V_DTENTRSAID = @C_ULTCOMP_DTENTRSAID;
               SET @V_NRNOTAFISC = @C_ULTCOMP_NRNOTAFISC;
               SET @V_QTITEMPROD = @C_ULTCOMP_QTITEMPROD;
               SET @V_VRUNITITEM = @C_ULTCOMP_VRUNITITEM;
               SET @V_VRFRETE    = @C_ULTCOMP_VRFRETE;
               SET @V_VRIPI      = @C_ULTCOMP_VRIPI;
               SET @V_QTPRZ      = @C_ULTCOMP_QTPRZ;

               IF @V_CONT = 0 BEGIN
                  INSERT INTO TRAB_SUGCOMPRA
                     (CDFILSUGCOMP, NRSUGCOMPRA,  CDFORSUGCOMP, CDPROSUGCOMP, DTREFSUGCOMP, NRDIACOMPRA,
                      NRDIAEXCESS,  DTMESANT01,   DTMESANT02,   DTMESANT03,   DTULTCOMPRA,  NRULTNOTAFIS,
                      QTULTITEMPRO, VRULTUNITITE, VRULTFRETE,   VRIPIULTCOMP, QTPRZULTCOMP, QTSAIDAANT01, QTSAIDAANT02, QTSAIDAANT03,
                      QTSAIDAATUAL, QTMEDIAMES,   QTESTOQSGCMP, QTSOLICFORNE, QTCOMPRA,     QTEXCESSO, NRITESUGCOMP)
                  VALUES
                     (@P_CDFILIAL ,   @P_NRSUGCOMPRA, @V_CDFORNECED, @C_REG_CDPRODUTO, @P_DTREFE,     @P_NRDIACOMPRA,
                      @P_NRDIAEXCESS, @P_DTQTDE1,     @P_DTQTDE2,    @P_DTQTDE3,       @V_DTENTRSAID, @V_NRNOTAFISC,
                      @V_QTITEMPROD,  @V_VRUNITITEM,  @V_VRFRETE,    @V_VRIPI,         @V_QTPRZ,      @V_QTDE1, @V_QTDE2, @V_QTDE3,
                      @V_QTDEATUAL,   @V_QTMEDIAMES,  @V_QTESTOQUE,  @V_QTPEDIDA,      @V_QTCOMPRA,   @V_QTEXCESSO, RIGHT(REPLICATE( 0, 10) + @V_NRITESUGCOMP, 10));
               END
               ELSE BEGIN
                  INSERT INTO TRAB_SUGCOMPRA
                     (CDFILSUGCOMP, NRSUGCOMPRA,  CDFORSUGCOMP, CDPROSUGCOMP, DTREFSUGCOMP, NRDIACOMPRA,
                      NRDIAEXCESS,  DTMESANT01,   DTMESANT02,   DTMESANT03,   DTULTCOMPRA,  NRULTNOTAFIS,
                      QTULTITEMPRO, VRULTUNITITE, VRULTFRETE,   VRIPIULTCOMP, QTPRZULTCOMP, NRITESUGCOMP)
                  VALUES
                     (@P_CDFILIAL ,   @P_NRSUGCOMPRA, @V_CDFORNECED, @C_REG_CDPRODUTO, @P_DTREFE,     @P_NRDIACOMPRA,
                      @P_NRDIAEXCESS, @P_DTQTDE1,     @P_DTQTDE2,    @P_DTQTDE3,       @V_DTENTRSAID, @V_NRNOTAFISC,
                      @V_QTITEMPROD,  @V_VRUNITITEM,  @V_VRFRETE,    @V_VRIPI,         @V_QTPRZ,      RIGHT(REPLICATE( 0, 10) + @V_NRITESUGCOMP, 10));
               END
               SET @V_NRITESUGCOMP = @V_NRITESUGCOMP + 1;

               SET @V_CONT = @V_CONT + 1;
               IF @V_CONT = 3 BEGIN
                  BREAK;
               END;
            END;
               SET @V_CDFORNECED = '';
               SET @V_DTENTRSAID  = '';
               SET @V_NRNOTAFISC  = '';
               SET @V_QTITEMPROD = '';
               SET @V_VRUNITITEM  = '';
               SET @V_VRFRETE       = '';
               SET @V_VRIPI           = '';
               SET @V_QTPRZ         = '';
            FETCH NEXT FROM C_ULTCOMP INTO @C_ULTCOMP_CDFILIAL,  @C_ULTCOMP_NRLANCTONF, @C_ULTCOMP_NRNOTAFISC,
                                           @C_ULTCOMP_DTENTRSAID,@C_ULTCOMP_CDFORNECED, @C_ULTCOMP_NRINSJURFORN,
                                           @C_ULTCOMP_NMRAZSOCFORN, @C_ULTCOMP_IDTPIJURFORN, @C_ULTCOMP_VRIPI,
                                           @C_ULTCOMP_VRFRETE, @C_ULTCOMP_QTPRZ, @C_ULTCOMP_QTITEMPROD, @C_ULTCOMP_VRUNITITEM;
         
         END;
         CLOSE C_ULTCOMP;
         DEALLOCATE C_ULTCOMP;

         SELECT @V_EXIST = COUNT(*)
         FROM TRAB_SUGCOMPRA
         WHERE CDFILSUGCOMP = @P_CDFILIAL
            AND NRSUGCOMPRA  = @P_NRSUGCOMPRA
            AND CDPROSUGCOMP = @C_REG_CDPRODUTO;

         IF @V_EXIST = 0 BEGIN
            INSERT INTO TRAB_SUGCOMPRA
               (CDFILSUGCOMP, NRSUGCOMPRA,  CDFORSUGCOMP, CDPROSUGCOMP, DTREFSUGCOMP, NRDIACOMPRA,
                NRDIAEXCESS,  DTMESANT01,   DTMESANT02,   DTMESANT03,   DTULTCOMPRA,  NRULTNOTAFIS,
                QTULTITEMPRO, VRULTUNITITE, VRULTFRETE,   VRIPIULTCOMP, QTPRZULTCOMP, QTSAIDAANT01, QTSAIDAANT02, QTSAIDAANT03,
                QTSAIDAATUAL, QTMEDIAMES,   QTESTOQSGCMP,    QTSOLICFORNE, QTCOMPRA,     QTEXCESSO, NRITESUGCOMP)
            VALUES
               (@P_CDFILIAL ,   @P_NRSUGCOMPRA, @V_CDFORNECED, @C_REG_CDPRODUTO, @P_DTREFE, @P_NRDIACOMPRA,
                @P_NRDIAEXCESS, @P_DTQTDE1,     @P_DTQTDE2,    @P_DTQTDE3,       @V_DTENTRSAID, @V_NRNOTAFISC,
                @V_QTITEMPROD,  @V_VRUNITITEM,  @V_VRFRETE,    @V_VRIPI,         @V_QTPRZ,      @V_QTDE1, @V_QTDE2, @V_QTDE3,
                @V_QTDEATUAL,   @V_QTMEDIAMES,  @V_QTESTOQUE,  @V_QTPEDIDA,      @V_QTCOMPRA,   @V_QTEXCESSO, RIGHT(REPLICATE( 0, 10) + @V_NRITESUGCOMP, 10));
            SET @V_NRITESUGCOMP = @V_NRITESUGCOMP + 1;
         END;

         FETCH NEXT FROM C_REG INTO  @C_REG_CDPRODUTO, @C_REG_CDARVPROD, @C_REG_SGUNIDADE, @C_REG_NMPRODUTO, @C_REG_VRFATOCONV;
      END;
      CLOSE C_REG;
      DEALLOCATE C_REG;
   END;

   IF @P_IDTPRELSUG = '2' BEGIN
      DECLARE C_PED CURSOR FOR
         SELECT DISTINCT
            FN.CDFORNECED,   PR.CDPRODUTO, PE.NRPEDIDO, IT.NRITEMPED,
            IT.QTITEMPED,IT.QTEXPITEMPED, PE.CDCLIENTE, PR.VRFATOCONV
         FROM
            NOTAFISCAL NF, ITEMPRODUTO IP, PRODFORNCOMP PF, FORNECEDOR FN,
            ITEMPEDIDO IT, PEDIDO      PE, CLIENTE  CL, FILIAL     FI,
            PRODUTO    PR
         WHERE
            (IT.CDFILIAL     = @P_CDFILIAL   ) AND
            (IP.CDFILIAL     = NF.CDFILIAL   ) AND
            (IP.NRLANCTONF   = NF.NRLANCTONF ) AND
            (IP.NRPEDIDO     = IT.NRPEDIDO   ) AND
            (IP.NRITEMPED    = IT.NRITEMPED  ) AND
            (IT.CDFILIAL     = IP.CDFILIALPED) AND
            (IT.CDPRODUTO    = PF.CDPRODCOMPL) AND
            (IT.IDSITITEMPED in ('1','2','3','7'))  AND
            (PE.CDFILIAL     = IT.CDFILIAL   ) AND
            (PE.NRPEDIDO     = IT.NRPEDIDO   ) AND
            (PE.IDSITPEDIDO  in ('1','2','6')) AND
            (CL.CDCLIENTE    = PE.CDCLIENTE  ) AND
            (FI.CDFILIAL     = PE.CDFILIAL   ) AND
            (FN.CDFORNECED   = PF.CDFORNECED ) AND
            (PR.CDPRODUTO    = PF.CDPRODCOMPL) AND
            (CHARINDEX( '_' + FN.CDFORNECED + '_', ISNULL(@P_CDFORNECED, '_' + FN.CDFORNECED + '_')) > 0) AND
            (CHARINDEX( '_' + CL.CDCLIENTE + '_',  ISNULL( @P_CDCLIENTE, '_' + CL.CDCLIENTE + '_')) > 0) AND
            ((NF.DTENTRSAID BETWEEN @P_DEEXP AND @P_ATEEXP) OR (@P_TDATA = 'T')) AND
            (PR.CDARVPROD BETWEEN @P_PRODINI AND @P_PRODFIN) AND
            (PR.CDPRODESTO IS NOT NULL)
         OPEN C_PED;
         FETCH NEXT FROM C_PED INTO @C_PED_CDFORNECED, @C_PED_CDPRODUTO, @C_PED_NRPEDIDO, @C_PED_NRITEMPED,
                                    @C_PED_QTITEMPED,  @C_PED_QTEXPITEMPED, @C_PED_CDCLIENTE,   @C_PED_VRFATOCONV;

      WHILE (@@FETCH_STATUS = 0) BEGIN
         SELECT
            @V_QTESTOQUE = MAX(PE.QTESTDIACON)
         FROM
            POSESTCONS PE
         WHERE
               (PE.CDFILIAL    = @P_CDFILIAL)
           AND (PE.CDPRODUTO   = @C_PED_CDPRODUTO)
           AND (PE.DTPOSESTCON = TEKNISA.DTMAXPOSEST(@P_CDFILIAL, @C_PED_CDPRODUTO, @P_DTPOSICAO + 1));

         INSERT INTO TRAB_SUGCOMPRA
            (CDFILSUGCOMP, NRSUGCOMPRA,  CDFORSUGCOMP,
             CDPROSUGCOMP, NRPEDSUGCOMP, NRITPSUGCOMP,
             CDCLISUGCOMP, QTCOMPRA,     QTESTOQSGCMP,
             NRITESUGCOMP)
         VALUES
            (@P_CDFILIAL, @P_NRSUGCOMPRA, @C_PED_CDFORNECED,
             @C_PED_CDPRODUTO, @C_PED_NRPEDIDO, @C_PED_NRITEMPED,
             @C_PED_CDCLIENTE, ISNULL( @C_PED_QTITEMPED, 0) - ISNULL(@C_PED_QTEXPITEMPED, 0), ISNULL(@V_QTESTOQUE, 0) * ISNULL(@C_PED_VRFATOCONV, 1),
             RIGHT(REPLICATE( 0, 10) + @V_NRITESUGCOMP, 10));

         SET @V_NRITESUGCOMP = @V_NRITESUGCOMP + 1;
         FETCH NEXT FROM C_PED INTO @C_PED_CDFORNECED, @C_PED_CDPRODUTO, @C_PED_NRPEDIDO, @C_PED_NRITEMPED,
                                    @C_PED_QTITEMPED,  @C_PED_QTEXPITEMPED, @C_PED_CDCLIENTE,   @C_PED_VRFATOCONV;
      END;
      CLOSE C_PED;
      DEALLOCATE C_PED;
   END;

   IF @P_IDGERASOLCMP = 'S' BEGIN
      EXECUTE GERA_SOLICMP @P_CDFILIAL,  @P_CDFILLAN, @P_NRSOLICMP, @P_DTENTSOLICMP,
                           @P_DTPOSICAO, @V_NRLISTA,  @P_NRSUGCOMPRA, @P_IDTPRELSUG, @P_IDMENSSOLI = @V_IDMENSSOLI OUTPUT;
      SET @P_IDMENSSOLI = @V_IDMENSSOLI;
   END;

   DELETE FROM LISTA
   WHERE NRLISTA = @V_NRLISTA;
END
GO

-- VERSAO --
EXEC ATUVEROBJ 'GERA_SUGESTAO_COMPRA','4.05.126';
GO

